



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>关于LWIP---UDP</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">关于LWIP---UDP</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-08 10:21:38 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>lwip是一个轻量级的TCP/IP协议栈（Lightweight TCP/IP Stack）实现，最初是瑞士计算机科学学院Adam Dunkels编写的一个应用于无操作系统的嵌入式系统中的TCP/IP协议栈，后来作为一个开源（open source）项目，由一个全球性的团队进行开发和维护。</p>
<p>已实现的部分有：</p>
<p>1. 标准的TCP/IP协议栈实现，包括TCP、UDP、ICMP、IP、ARP、DHCP；</p>
<p>ICMP（Internet control message protocol）：网络维护和调试。</p>
<p>UDP（User datagram protocol）</p>
<p>DHCP（Dynamic host configuration protocol）</p>
<p>ARP（Address resolution protocol）</p>
<p>2.非标准Socket接口，lwip提供了一套Socket API，这套API的标准与正常操作系统下的Socket API的形式不是很一致，我们先前已经在这套API上实现了Web Server，已测试在没有Mobile IP环境下工作正常。</p>
<p>下面我们就一个lwip典型的UDP协议工作过程作为对lwip的简单介绍。</p>
<p>UDP发送过程：</p>
<p>1．应用层：绑定UDP套接字<br />我们必须先创建一个UDP套接字，通过调用udp_new()进行申请，然后调用udp_bind()绑定在 UDP端口上，在这个调用过程中，我们必须编写一个用于处理这个UDP套接字接收到的数据报文的函数，并把这个函数作为udp_bind()的参数，以后 当套接字接收到数据报文时会自动调用这个函数，我们将在后面介绍这个函数怎么调用的。绑定结束之后，必须调用udp_connect()将数据报文的目的 地址绑定在UDP的数据结构中，最后就是调用udp_send()把数据报文发送出去。</p>
<p>udp_bind()的处理流程图</p>
<p><img referrerpolicy="no-referrer"src="http://hi.csdn.net/attachment/201106/16/0_13082061428E17.gif" /></p>
<p>2．传输层的处理<br />做好应用层的处理之后，数据报文被提交到UDP层，udp_send()函数中首先给数据报文加入UDP头部，然后调用ip_route()选择一个合适的网络接口进行发送，最后调用ip_output()把数据报文传入IP层。</p>
<p>3．IP层的处理<br />ip_route()函数比较各个网络接口的IP地址是否与目的IP地址在同一子网中，如果有，就把它当成发送的网络接口返回，如果没有就返回一个默认的网络接口。<br />在 ip_output()函数中，先给数据报文加上IP头部，然后比较目的IP地址与网络接口的IP地址是否在同一网段，如果不是，就必须先把数据报文发送 到网关，于是使用网关的IP地址作为目的主机，如果目的IP地址与网络接口的IP地址在同一网段，则把目的IP地址作为目的主机。接着调用 arp_lookup()在ARP缓存中查找目的主机的MAC地址，找到了调用ethernet_output()把数据报文传入到数据链路层发送，如果 找不到，就调用arp_query()发送ARP请求解析目的主机的MAC地址。</p>
<p>4．ARP协议的处理<br />arp_lookup()实现在本地ARP缓存中查找目的主机的MAC地址，找到了返回该MAC地址，找不到返回NULL。<br />arp_query()函数中构造一个ARP请求报文，然后调用ethernet_output()把该报文送到数据链路层发送。</p>
<p>5． 数据链路层的处理<br />数据链路层的处理就是给数据报文添上相对的以太网头部，然后调用lowlever_output()直接把报文传送出去。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rql7jx9o.html">Atitit zxing二维码qr码识别解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mjg668.html">在ubuntu&sol;deepin&sol;mint等系统中使用命令删除文件或文件夹</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kmezj9.html">onDestroy &amp;&num;160&semi;和 onBackPressed、onfinish 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7nn4e9.html">移动端重构实战系列2&mdash;&mdash;line list</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1y3k4q.html">redis使用心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdegg7x9.html">Oracle &plus; Entity Framework 更新没有设置主键的表</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4dpvq.html">iOS UITableView的使用大全－备用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1xkv79.html">&dollar;&period;unique&lpar;&rpar; 对象组成的数组去掉重复对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd1mny8.html">Path Sum&comma;Path Sum II</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wo70xq.html">eclipse启动tomcat 访问http&colon;&sol;&sol;localhost&colon;8080 报404错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j5dww8.html">汉字转拼音  oracle方式 &lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p7ez48.html">IE和FF的差异</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyoj2z9.html">一个可以将 json 字符串 直接绑定到 view 上的Android库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k4o529.html">POJ 3190 Stall Reservations贪心</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me6o2rq.html">《C&plus;&plus; Primer》学习笔记：向vector对象添加元素蕴含的编程假定</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rdnz39.html">4、new一个对象的时候，初始化顺序&colon;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q250vwlq.html">启动tomcat出现内存溢出错误 java&period;lang&period;OutOfMemoryError&colon; PermGen space</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwlrrj9.html">Linux课题实践五&mdash;&mdash;字符集总结与分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25exzwq.html">UTF8编码的Base64解密 MSSQL实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/960ez2y9.html">gdb debug</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxnppgd8.html">Node&period;js HTTP 使用详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv6xjjq.html">android layout的布局</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj01p49.html">SQL Server 2008 对XML 数据类型操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wo71vq.html">（六）boost库之内存管理shared&lowbar;ptr</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmgz409.html">Unix&sol;Linux环境C编程入门教程&lpar;27&rpar;  内存那些事儿</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdem0579.html">网路流程图 TCP&sol;IP</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdeme579.html">linux守护进程解读</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1wp079.html">iOS 创建上线证书</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1wjrj9.html">C&num;  获取网站的 IIS 站点名称 ，获取站点当前连接数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd6lrl8.html">Data Recovery Advisor &lpar;DRA&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
